#!/bin/sh
# AMI Setup script
# (c) 1993 X. Bonnaire, MASI Laboratory

# Setup installation script
# AMI_ROOT_DIR is the home directory for AMI
# the ami root dir is now the first argument of the script ($1)

install_no_maple() {
cp $AMI_ROOT_DIR/Interlocuteurs/AMI-Net/Services/Renseignements/questions.0.NO_MAPLE $AMI_ROOT_DIR/Interlocuteurs/AMI-Net/Services/Renseignements/questions.0
   	cp $AMI_ROOT_DIR/Interlocuteurs/AMI-Net/Services/Renseignements/questions.1.NO_MAPLE $AMI_ROOT_DIR/Interlocuteurs/AMI-Net/Services/Renseignements/questions.1
   	cp $AMI_ROOT_DIR/Interlocuteurs/AMI-Net/Services/Renseignements/s-m/ordinaire.0.NO_MAPLE $AMI_ROOT_DIR/Interlocuteurs/AMI-Net/Services/Renseignements/s-m/ordinaire.0
   	cp $AMI_ROOT_DIR/Interlocuteurs/AMI-Net/Services/Renseignements/s-m/ordinaire.1.NO_MAPLE $AMI_ROOT_DIR/Interlocuteurs/AMI-Net/Services/Renseignements/s-m/ordinaire.1
}

install_maple() {
if [ -f $AMI_ROOT_DIR/Interlocuteurs/AMI-Net/Ordinaire/Executable/APPLICATION/maple ]
  then
     rm $AMI_ROOT_DIR/Interlocuteurs/AMI-Net/Ordinaire/Executable/APPLICATION/maple
     ln -s $MAPLE_HOME/bin/maple $AMI_ROOT_DIR/Interlocuteurs/AMI-Net/Ordinaire/Executable/APPLICATION/maple
  fi
   	   	
if [ -f $AMI_ROOT_DIR/Interlocuteurs/AMI-Net/PILOTEMAPLE/Executable/maple ]
   then
     rm $AMI_ROOT_DIR/Interlocuteurs/AMI-Net/PILOTEMAPLE/Executable/maple
     ln -s $MAPLE_HOME/bin/maple $AMI_ROOT_DIR/Interlocuteurs/AMI-Net/PILOTEMAPLE/Executable/maple
   fi

   	cp $AMI_ROOT_DIR/Interlocuteurs/AMI-Net/Services/Renseignements/questions.0.MAPLE $AMI_ROOT_DIR/Interlocuteurs/AMI-Net/Services/Renseignements/questions.0
   	cp $AMI_ROOT_DIR/Interlocuteurs/AMI-Net/Services/Renseignements/questions.1.MAPLE $AMI_ROOT_DIR/Interlocuteurs/AMI-Net/Services/Renseignements/questions.1
   	cp $AMI_ROOT_DIR/Interlocuteurs/AMI-Net/Services/Renseignements/s-m/ordinaire.0.MAPLE $AMI_ROOT_DIR/Interlocuteurs/AMI-Net/Services/Renseignements/s-m/ordinaire.0
   	cp $AMI_ROOT_DIR/Interlocuteurs/AMI-Net/Services/Renseignements/s-m/ordinaire.1.MAPLE $AMI_ROOT_DIR/Interlocuteurs/AMI-Net/Services/Renseignements/s-m/ordinaire.1
}

# First verify if we are root ?

user=`/usr/ucb/whoami`
if [ "$user" != "root" ] 
  then
	echo "Sorry, must be root to install AMI"
	exit 1
fi

if [ $# != 1 ]
   then
   	echo "Usage: AMIsetup <ami_root_directory>"
   	exit 10
fi

# Set the ami root directory and check it!
AMI_ROOT_DIR=${1:=/usr/local/ami}
if [ ! -d $AMI_ROOT_DIR/Interlocuteurs ]
   then
   	echo "Please give a valid ami directory"
   	echo "Usage: AMIsetup <ami_root_directory>"
   	exit 10
   fi

# make sure the defaut will be NO_MAPLE !
trap install_no_maple 2

echo "External software installation:"

# Ask if MAPLE is installed ?
#
IS_MAPLE=no
echo -n "Is MAPLE installed on your system [$IS_MAPLE]: "
read answer
IS_MAPLE=${answer:=$IS_MAPLE}

# If MAPLE is installed then ask where ?
#
if [ "$IS_MAPLE" != "no" ]
   then
	MAPLE_HOME=/usr/local/MAPLE
	echo -n "Give the home directory for MAPLE [$MAPLE_HOME]: "
	read answer
	MAPLE_HOME=${answer:=$MAPLE_HOME}
	if [ ! -f $MAPLE_HOME/bin/maple ]
           then
   		echo "Unable to find MAPLE here !"
   		if [ -f $AMI_ROOT_DIR/Interlocuteurs/AMI-Net/Ordinaire/Executable/APPLICATION/maple ]
   	   	  then
   	   		rm $AMI_ROOT_DIR/Interlocuteurs/AMI-Net/Ordinaire/Executable/APPLICATION/maple
   	   	fi
   	   	if [ -f $AMI_ROOT_DIR/Interlocuteurs/AMI-Net/PILOTEMAPLE/Executable/maple ]
   		  then
     			rm $AMI_ROOT_DIR/Interlocuteurs/AMI-Net/PILOTEMAPLE/Executable/maple
		fi
   	   	echo "MAPLE installation aborted"
   	   	install_no_maple
   	   	IS_MAPLE=no
   	fi
fi

if [ "$IS_MAPLE" = "no" ] 
   then
   	install_no_maple
   else
   	install_maple
   	echo "MAPLE installation completed"
fi

# External software installation is finished
#
echo
echo "External software installation completed"

# Let's change file permissions for executables
# and put s bit to amical command

echo -n "Changing file permissions, please wait..."

cd $AMI_ROOT_DIR
chmod -R a+rx *

echo "Done"
chown root.daemon $AMI_ROOT_DIR/commun/sun4/bin/amical
chmod u+s $AMI_ROOT_DIR/commun/sun4/bin/amical

if [ -f $AMI_ROOT_DIR/commun/sun4/bin/amitest ]
   then
       chown root.daemon $AMI_ROOT_DIR/commun/sun4/bin/amitest
       chmod u+s $AMI_ROOT_DIR/commun/sun4/bin/amitest
fi

echo "Done"

echo "AMI Setup completed"
echo "Run the amical command to start AMI framework"
echo "Enjoy AMI!"


