#!/bin/sh
# AMI Extraction script
# (c) 1993 X. Bonnaire, MASI Laboratory



# Function
# Skip the first tar file on the tape (installation scripts)
#

ami_skiptape()
{
if [ "$AMI_DEV_HOST" != "$AMI_HOST" ]
   then
   	rsh $AMI_DEV_HOST "mt -f $AMI_DEVICE fsf 1"
   	if [ "$?" != "0" ]
   	   then
   	   	echo "Unable to use remote device $AMI_DEVICE on host $AMI_DEV_HOST"
   	   	exit 1
   	fi
   else
   	mt -f $AMI_DEVICE fsf 1
   	if [ "$?" != "0" ]
   	   then
   	   	echo "Unable to use remote device $AMI_DEVICE on host $AMI_DEV_HOST"
   	   	exit 1
   	fi
fi;
}

#=====================================================================================

# Function 
# Extract all AMI files from tape
#

ami_extract_tape()
{
echo
echo "Extracting for :"
cat ./AMIversion.data

if [ "$AMI_DEV_HOST" != "$AMI_HOST" ]
   then
   	extractcmd="rsh -n $AMI_DEV_HOST dd if=$AMI_DEVICE bs=20b | tar xBfb - 20"
   else
   	extractcmd="./gtar xpf $AMI_DEVICE"
fi
CURRENT_DIR=`pwd`
cd $AMI_ROOT_DIR
$CURRENT_DIR/$extractcmd
if [ "$?" = "0" ]
   then
   	echo "AMI file extraction completed"
   else 
   	echo "Problem while reading tape"
   	exit 10
fi;
}

#=====================================================================================

# Function 
# rewind tape
#
ami_rewind()
{
echo "Rewinding tape..."
if [ "$AMI_DEV_HOST" = "$AMI_HOST" ]
   then
   	mt -f $AMI_DEVICE rew
   else
   	rsh $AMI_DEV_HOST mt -f $AMI_DEVICE rew
fi
echo "Done";
}

#=====================================================================================

# Function 
# Extract all AMI files from ftp
#

ami_extract_ftp()
{
echo
echo "Extracting for :"
cat ./AMIversion.data

CURRENT_DIR=`pwd`
cd $AMI_ROOT_DIR
$CURRENT_DIR/gtar xpf $CURRENT_DIR/$AMI_DEVICE
if [ "$?" = "0" ]
   then
   	echo "AMI file extraction completed"
   else 
   	echo "Problem while reading ftp distribution"
   	exit 10
fi;
}

#=====================================================================================

# We can now extract AMI distribution from
# any user account

# Check if we are extracting from tape or from FTP

if [ "$AMI_DEVICE" != "ami.tar" ]
   then
   	ami_skiptape
   	ami_extract_tape
   	ami_rewind
fi

if [ "$AMI_DEVICE" = "ami.tar" ]
   then
   	ami_extract_ftp
fi
   	

