#!/bin/sh
# AMI master installation script
# (c) 1993 X. Bonnaire, MASI Laboratory

#
# The AMI installation can now be made by any user
# The AMISetup script has to be run by root after
# this installation step
#


# Few variables initialisation

AMI_HOST=`hostname`; export AMI_HOST
AMI_DEV_HOST=$AMI_HOST; export AMI_DEV_HOST


# print AMI installation header
echo "AMI installation"
echo "Please read carefully all the following questions."
echo "Pressing <RETURN> at the prompt takes the default choise."
echo

#
# Choose the installation device
#

AMI_DEVICE="ami.tar.gz"
echo -n "Enter installation device [$AMI_DEVICE]: "
read answer
AMI_DEVICE=${answer:=$AMI_DEVICE}
export AMI_DEVICE

#
# Choose AMI installation directory
# 

AMI_ROOT_DIR="/usr/local/ami"
echo -n "Enter AMI installation directory [$AMI_ROOT_DIR]: "
read answer
AMI_ROOT_DIR=${answer:=$AMI_ROOT_DIR}
export AMI_ROOT_DIR

if [ -d $AMI_ROOT_DIR ] 
   then
	echo -n "$AMI_ROOT_DIR already exist, continue [y]: "
	read answer
	if [ "$answer" = "n" ] 
	  then
		echo "Installation aborted for host $HOST"
		exit 2
	fi
   else
   	mkdir $AMI_ROOT_DIR
fi
echo

#
# Where is the device ?
# If not a device file then uncompress it with gzip
#
if [ -c $AMI_DEVICE ]
   then
	echo -n "Enter the hostname for device $AMI_DEVICE [$AMI_DEV_HOST]: "
	read answer
	AMI_DEV_HOST=${answer:=$AMI_DEV_HOST}
   elif [ -f $AMI_DEVICE ]
    then
	echo "Uncompressing AMI..."
	./gzip -d ./ami.tar.gz
	AMI_DEVICE=ami.tar
	echo "Done"
    else 
    	echo "Not a valid device!"
    	echo "Installation aborted."
    	exit 10;
fi


#
# Run AMI extraction script (AMIextract)
#

if [ -f ./AMIextract.sh ] 
   then
	chmod ugo+x ./AMIextract.sh
	./AMIextract.sh
	if [ "$?" != "0" ] 
	   then
		echo "Installation aborted from AMIextract"
		exit 3
	fi
  else  
  	echo "Unable to find AMIextract.sh !"
  	echo "Installation aborted"
  	exit 3
fi

# The external installation software has been moved
# to the AMISetup script to allow any user to do the
# previous part of the installation.

#
# AMI installation is completed
#

echo "AMI installation successfull"
echo
echo "Please run the AMISetup script as root to setup"
echo "external software and file permissions"



