 /************************************************************
  *	Auteur			:	Denis Poitrenaud
  *	Programme		:	executeur.c
  *	Module			:	Execution d'un reseau de Petri
  *	
  *	Mercredi	27/01/93	C ANSI
  ************************************************************/

#include <setjmp.h>
#include <signal.h>
#include "libou.h"
#include "TraiteCamiANSI.h"

#define ACTION(NomAction)	void NomAction(char* NomTransition, char* Couleur)

#define COLOR					Couleur
#define TRANSITION			NomTransition
#define SEND_CDE(Cde)		EnvoiMessageClient(Cde)

#define BAD_ACTION 		-1300
#define NUMSIGNAL  		-1310
#define CMD_LONG_NULLE 	"Rn(-1320,0:)"
#define CMD_INCONNUE 	"Rn(-1330,0:)"
#define ACTION_INCONNUE	"Rn(-1340,0:)"
#define CMD_INCONNUE2	"Rn(-1350,0:)"

/*********************************************************/

/* Texte des fonctions du modelisateur */
#include "tmp.c"

/*********************************************************/

#define INDICEMAX				NBFONCTIONS -1 /* macro definie dans tmp.c */

/* Declaration du tableau decrivant les fonctions du modelisateur */
/*********************************************************/
typedef void ( *TypeAction)(char* NomTransition, char* Couleur);

typedef struct
	{
		char 			NomFonction[255];
		TypeAction 	PtFonction;
	}	t_DescFonction;
	
t_DescFonction TableauFonctions[NBFONCTIONS] = INITTABFCT; /* macros definies dans tmp.c */

int 		i; /* indice servant a parcourir le tableau ci-dessus, mis en global pour SegmentationViolation */

jmp_buf	my_environment; /* environnement du process pour setjump et longjump */

/* Fonction de traitement des signaux d'erreur provoques par les fonctions de l'utilisateur */
/************************************************************/
void SegmentationViolation(int Sig)
{
	char 	Cde[255];
	
	sprintf(	Cde,"Rn(%d,%d:%s)", BAD_ACTION,
				strlen(TableauFonctions[i].NomFonction), TableauFonctions[i].NomFonction);
	SEND_CDE(Cde);
	sprintf(	Cde,"Rn(%d,2:%2d)", NUMSIGNAL,Sig);
	SEND_CDE(Cde);
	longjmp(my_environment,1);	
}

/*********************************************************/
void main(int argc,char* argv[])

{
	char				CdeLue[255];
	int				Resultat, Paramc, taille;
	char**			Paramv;
	
	signal(SIGSEGV,SegmentationViolation);
	signal(SIGFPE,SegmentationViolation);
	signal(SIGBUS,SegmentationViolation);
	InitCommunicationClient(argc,argv); /* Initialisation des communication avec Desir via le serveur */
	InitDecodeCami();	/* initialisation du module de decodage des commandes cami */
	do	
	{
		taille = ReceptionMessageClient(CdeLue);
		if (taille <= 0)
		{
			SEND_CDE("DE()");
			SEND_CDE(CMD_LONG_NULLE);
			SEND_CDE("FE()");
			exit();
		}
		else
		{
			Resultat = DecodeCami(CdeLue,&Paramc,&Paramv);
			SEND_CDE("DE()");
			switch (Resultat)
			{
			case CAMI_ERR :
				SEND_CDE(CMD_INCONNUE);
				break;
			case CAMI_Ex :
				for	(i=0; 
						(i < INDICEMAX) && (strcmp(Paramv[1], TableauFonctions[i].NomFonction) != 0);
						i++);
				if (strcmp(Paramv[1], TableauFonctions[i].NomFonction) == 0)
				{
					if (!setjmp(my_environment))
						(TableauFonctions[i].PtFonction)(Paramv[2], Paramv[3]);
				}
				else
					SEND_CDE(ACTION_INCONNUE);
				break;
			case CAMI_En : 
				break;
			default :
				SEND_CDE(CMD_INCONNUE2);
				break;
			}
			SEND_CDE("FE()");
		}
	} while (Resultat != CAMI_En);
	DemanderFermetureClient();
}

