with UTILITAIRES_DE_TRACE, STATISTIQUES, MECANISME_DE_DIAGNOSTIC, SYSTEM_ENVIRONMENT, TEXT_IO;
use UTILITAIRES_DE_TRACE, STATISTIQUES, MECANISME_DE_DIAGNOSTIC, SYSTEM_ENVIRONMENT, TEXT_IO;

package body COMPOSANT_EXTERNE_XWINDOWOBJECTS is

   TRACE : BOOLEAN := FALSE;
   FIFO  : FILE_TYPE;

   ----------------------------------------------------------
   ----------------------------------------------------------
   -- Primitives de l'unite COMPOSANT_EXTERNE_XWINDOWOBJECTS
   ----------------------------------------------------------
   ----------------------------------------------------------

   -- L'ensemble des primitives associees aux places d'interfaces en entree

   ----------------------------------------------------------
   -- XWINDOWOBJECTS_ACCES_ENTREE_CREATE
   ----------------------------------------------------------

   procedure XWINDOWOBJECTS_ACCES_ENTREE_CREATE (PARAMETRE : in CREAT) is


   begin

      -- Trace puisque DEBUG a ete selectionne en mode DEVELOPPEUR
      if TRACE then
         TRACE_AVEC_RC ("--> XWINDOWOBJECTS_ACCES_ENTREE_CREATE");
      end if;

      case PARAMETRE.CREAT_CHAMP_1 is
         when TYPE_OBJECT_RECTANGLE =>
            PUT_LINE (FIFO,
                      "C R" & INTEGER'IMAGE (PARAMETRE.CREAT_CHAMP_2) & INTEGER'IMAGE (PARAMETRE.CREAT_CHAMP_3) &
                      INTEGER'IMAGE (PARAMETRE.CREAT_CHAMP_4) & INTEGER'IMAGE (PARAMETRE.CREAT_CHAMP_5) &
                      INTEGER'IMAGE (PARAMETRE.CREAT_CHAMP_6));
         when TYPE_OBJECT_CERCLE =>
            PUT_LINE (FIFO,
                      "C C" & INTEGER'IMAGE (PARAMETRE.CREAT_CHAMP_2) & INTEGER'IMAGE (PARAMETRE.CREAT_CHAMP_3) &
                      INTEGER'IMAGE (PARAMETRE.CREAT_CHAMP_4) & INTEGER'IMAGE (PARAMETRE.CREAT_CHAMP_5) & " 0");
         when others =>
            raise STORAGE_ERROR; -- ne dois JAMAIS arriver
      end case;
      delay 0.01;
      if TRACE then
         TRACE_AVEC_RC ("<-- XWINDOWOBJECTS_ACCES_ENTREE_CREATE");
      end if;
   end XWINDOWOBJECTS_ACCES_ENTREE_CREATE;

   ----------------------------------------------------------
   -- XWINDOWOBJECTS_ACCES_ENTREE_MOVE
   ----------------------------------------------------------

   procedure XWINDOWOBJECTS_ACCES_ENTREE_MOVE (PARAMETRE : in MOV) is

   begin

      -- Trace puisque DEBUG a ete selectionne en mode DEVELOPPEUR
      if TRACE then
         TRACE_AVEC_RC ("--> XWINDOWOBJECTS_ACCES_ENTREE_MOVE");
      end if;

      -- envoyer l'ordre a Tagadix

      PUT_LINE (FIFO,
                "M" & INTEGER'IMAGE (PARAMETRE.MOV_CHAMP_1) & INTEGER'IMAGE (PARAMETRE.MOV_CHAMP_2) &
                INTEGER'IMAGE (PARAMETRE.MOV_CHAMP_3));
      delay 0.01;


      if TRACE then
         TRACE_AVEC_RC ("<-- XWINDOWOBJECTS_ACCES_ENTREE_MOVE");
      end if;
   end XWINDOWOBJECTS_ACCES_ENTREE_MOVE;

   ----------------------------------------------------------
   -- XWINDOWOBJECTS_ACCES_ENTREE_DESTROY
   ----------------------------------------------------------

   procedure XWINDOWOBJECTS_ACCES_ENTREE_DESTROY (PARAMETRE : in NUM_OBJECT) is

   begin

      -- Trace puisque DEBUG a ete selectionne en mode DEVELOPPEUR
      if TRACE then
         TRACE_AVEC_RC ("--> XWINDOWOBJECTS_ACCES_ENTREE_DESTROY");
      end if;

      -- Envoyer l'ordre a Tagadix

      PUT_LINE (FIFO, "D" & INTEGER'IMAGE (PARAMETRE));
      delay 0.01;

      if TRACE then
         TRACE_AVEC_RC ("<-- XWINDOWOBJECTS_ACCES_ENTREE_DESTROY");
      end if;
   end XWINDOWOBJECTS_ACCES_ENTREE_DESTROY;

   ----------------------------------------------------------
   -- XWINDOWOBJECTS_ACCES_ENTREE_INIT
   ----------------------------------------------------------

   procedure XWINDOWOBJECTS_ACCES_ENTREE_INIT is

      STATUS : EXIT_STATUS;

   begin

      -- Trace puisque DEBUG a ete selectionne en mode DEVELOPPEUR
      if TRACE then
         TRACE_AVEC_RC ("--> XWINDOWOBJECTS_ACCES_ENTREE_INIT");
      end if;

      -- Creation du tube

      STATUS := EXEC_SHELL_COMMAND ("/usr/etc/mknod LIEN_DE_COMMUNICATION p");

      -- Lancement du process esclave

      STATUS := EXEC_SHELL_COMMAND ("tagadix LIEN_DE_COMMUNICATION &");

      -- Ouverture du tube en lecture

      OPEN (FILE => FIFO, MODE => OUT_FILE, NAME => "LIEN_DE_COMMUNICATION", FORM => "BUFFER_SIZE => 0");

      if TRACE then
         TRACE_AVEC_RC ("<-- XWINDOWOBJECTS_ACCES_ENTREE_INIT");
      end if;

   end XWINDOWOBJECTS_ACCES_ENTREE_INIT;

   ----------------------------------------------------------
   -- XWINDOWOBJECTS_ACCES_ENTREE_FINISH
   ----------------------------------------------------------

   procedure XWINDOWOBJECTS_ACCES_ENTREE_FINISH is

      STATUS : EXIT_STATUS;

   begin

      -- Trace puisque DEBUG a ete selectionne en mode DEVELOPPEUR
      if TRACE then
         TRACE_AVEC_RC ("--> XWINDOWOBJECTS_ACCES_ENTREE_FINISH");
      end if;

      -- Ordre de fin a Tagadix

      PUT_LINE (FIFO, "T");

      -- Fermer et detruire le tube

      delay 0.1;
      CLOSE (FIFO);
      STATUS := EXEC_SHELL_COMMAND ("/usr/bin/rm -r LIEN_DE_COMMUNICATION");

      if TRACE then
         TRACE_AVEC_RC ("<-- XWINDOWOBJECTS_ACCES_ENTREE_FINISH");
      end if;
   end XWINDOWOBJECTS_ACCES_ENTREE_FINISH;


end COMPOSANT_EXTERNE_XWINDOWOBJECTS;
