/***************************************************************************
*
* Copyright (c) 1989, 1990, 1991, 1992, 1993
* by Helsinki University of Technology, Digital Systems Laboratory.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  baltree.h
*
* Part of: PROD's programs "gphgen", probe, prpp, and strong
*
* Author:  Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     .
*
* Version history:
*     $Log$
***************************************************************************/

typedef struct AVL
{
    char *element;
    int balance;
    struct AVL *left;
    struct AVL *right;
} AVL;

typedef char *(*BFUNC)();

typedef struct BALTOOLS
{
    char *(*copy)();
    void (*discard)();
    void (*dump)();
    int (*keyCmp)();
    BOOL (*prefix)();
} BALTOOLS;

typedef struct BALTREE
{
    unsigned long elCount;
    AVL *root;
    BALTOOLS *tools;
} BALTREE;

#define BalTrGElCount(balTree) ((balTree)->elCount)
#define BalTrIElCount(balTree) (((balTree)->elCount)++)
#define BalTrDElCount(balTree) (((balTree)->elCount)--)
#define BalTrGRoot(balTree) ((balTree)->root)
#define BalTrARoot(balTree) (&((balTree)->root))
#define BalTrSRoot(balTree,_root) ((balTree)->root = (_root))

#define BalTrAlloc() ((BALTREE *) Allocate(sizeof(BALTREE)))
extern BALTREE *BalTrCreate();
extern BALTREE *BalTrCopy();
extern void BalTrDestroy();
extern BALTREE *BalTrCp();
extern void BalTrDc();
extern void BalTrDump();
extern TOOLS balTrTools;
extern void BalTrApply();
extern void BalTrBackApply();
extern BALTREE *BalTrImage();
extern char *BalTrInsert();
extern char *BalTrDelete();
extern char *BalTrElement();
extern char *BalTrGrPrefix();
extern char *BalTrLsPrefix();
extern char *BalTrGrEqPrefix();
extern char *BalTrLsEqPrefix();
extern char *BalTrNext();
extern char *BalTrPrev();
extern char *BalTrFirst();
extern char *BalTrLast();
