/***************************************************************************
*
* Copyright (c) 1989, 1990, 1991, 1992, 1993
* by Helsinki University of Technology, Digital Systems Laboratory.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  encode.h
*
* Part of: PROD's programs "gphgen", probe, and prpp
*
* Authors: Marko Rauhamaa and Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     .
*
* Version history:
*     $Log$
***************************************************************************/

extern unsigned ingNofClasses;
#define IngGNofClasses() ingNofClasses
extern unsigned ingNofTransitions;
#define IngGNofTransitions() ingNofTransitions
extern unsigned *ingProfile;
#define IngGProfile(transition) (ingProfile[transition])
#define IngIProfile(transition,value) (ingProfile[transition] = (value))
extern unsigned *ingFdProfile;
#define IngGFdProfile(transition) (ingFdProfile[transition])
#define IngIFdProfile(transition,value) (ingFdProfile[transition] = (value))
extern char *ingIsFact;
#define IngIsFact(transition) (ingIsFact[transition])
#define IngIIsFact(transition,value) (ingIsFact[transition] = (value))
extern BOOL facts;
#define Facts() facts
#define SetFacts() (facts = TRUE)
#define ResetFacts() (facts = FALSE)

extern unsigned engBufSize;
#define EngBufSize() engBufSize
extern DATATYPE *engBuffer;
#define EngBuffer() engBuffer
#define	EngSBuffer(siz) \
(engBufSize = (unsigned) (siz), \
 engBuffer = (DATATYPE *) AllocArray(engBufSize, sizeof(DATATYPE)))
extern void BaseInit();
extern STATE *InitialState();
extern unsigned TupEncode();
extern TUPLE *TupDecode();
extern unsigned StaEncode();
extern void StaDecode();
extern unsigned InsEncode();
extern DOMAIN *InsDecode();
extern int BTupComp();
extern int InsComp();
extern BOOL FdEqual();

#define NUMERIC 16
#define SYMBOLIC 256

#define Encode(x) \
( \
    ((x) < NUMERIC) ? \
        (x) \
    : \
        ( \
            ((x) > (MAXDOMAIN - SYMBOLIC)) ? \
                (MAXDOMAIN - ((x) - NUMERIC)) \
            : \
                ((x) + SYMBOLIC) \
        ) \
)

#define Decode(x) \
( \
    ((x) < NUMERIC) ? \
        (x) \
    : \
        ( \
            ((x) < (NUMERIC + SYMBOLIC)) ? \
                (MAXDOMAIN - ((x) - NUMERIC)) \
            : \
                ((x) - SYMBOLIC) \
        ) \
)

#define VALBITS (BITSPERBYTE - 1)
#define VALSIZE (1 << VALBITS)
#define VALMASK (VALSIZE - 1)
#define SEPMK ((DATATYPE) (VALSIZE + 1))
#define CNTMK ((DATATYPE) (VALSIZE + 2))
#define SPECIALMIN ((DATATYPE) (VALSIZE + 3))

#define IncLen(_val, _len) \
if ((_val) < VALSIZE) \
    (_len)++; \
else \
    for ((_len)++; (_val); (_val) >>= VALBITS) \
        (_len)++;

#define PutValue(_val, _p) \
if ((_val) < VALSIZE) \
    *(_p)++ = (_val) + 1; \
else \
    { \
        register unsigned q; \
 \
        for (q = 0; (_val); (_val) >>= VALBITS) \
	    (_p)[++q] = ((_val) & VALMASK) + 1; \
        *(_p) = (SPECIALMIN - 2) + (DATATYPE) q; \
	(_p) += q + 1; \
    }

#define GetValue(_val, _p) \
if (*(_p) <= (DATATYPE) VALSIZE) \
    (_val) = *(_p)++ - 1; \
else \
    { \
        register unsigned q; \
 \
        q = *(_p) - (SPECIALMIN - 2); \
        for ((_val) = (_p)[q--] - 1; q; (_val) |= (_p)[q--] - 1) \
            (_val) <<= VALBITS; \
	(_p) += *(_p) - (SPECIALMIN - 3); \
    }

#define SepCode(_p) (*(_p)++ = SEPMK)
#define SepAt(_p) (*(_p) == SEPMK)
#define SepPass(_p) ((_p)++)
#define CntCode(_p) (*(_p)++ = CNTMK)
#define CntAt(_p) (*(_p) == CNTMK)
#define CntPass(_p) ((_p)++)
