/***************************************************************************
*
* Copyright (c) 1989, 1990, 1991, 1992, 1993
* by Helsinki University of Technology, Digital Systems Laboratory.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  gphutil.h
*
* Part of: PROD's programs "gphgen", probe, prpp, and strong
*
* Author:  Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     .
*
* Version history:
*     $Log$
***************************************************************************/

#ifdef UNIX
typedef int BINARYFILE;
#define NotBinaryFile(file) ((file) < 0)
#else
typedef FILE *BINARYFILE;
#define NotBinaryFile(file) (!(file))
#endif

/* FileName allocates space for string "name.suffix" and returns the string. */
extern char *FileName(/* name, suffix */);
/*
    char *name;
    char *suffix;
*/

#ifdef UNIX
#ifdef MAPTOMEM
typedef struct MMFILE
{
    char *start;
    unsigned len;
    unsigned offset;
} MMFILE;

extern MMFILE *MapToMem(/* bFile, len, actLen */);
/*
    BINARYFILE bFile;
    unsigned len;
    unsigned actLen;
*/

extern void MapFlush(/* mmFile, len, bFile */);
/*
    MMFILE *mmFile;
    unsigned len;
    BINARYFILE bFile;
*/

extern void Unmap(/* mmFile, len, bFile, wr */);
/*
    MMFILE *mmFile;
    unsigned len;
    BINARYFILE bFile;
    BOOL wr;
*/
#endif
#endif

extern BINARYFILE CreateUpdate(/* name */);
/*
    char *name;
*/

extern BINARYFILE CreateWrite(/* name */);
/*
    char *name;
*/

extern BINARYFILE OpenRead(/* name */);
/*
    char *name;
*/

extern BINARYFILE OpenUpdate(/* name */);
/*
    char *name;
*/

extern void OwnClose(/* file */);
/*
    BINARYFILE file;
*/

extern void OwnFlush(/* file */);
/*
    BINARYFILE file;
*/

extern void SeekAbs(/* file, pos */);
/*
    BINARYFILE file;
    unsigned long pos;
*/

extern void ReadLng(/* buf, cnt, file */);
/*
    unsigned long *buf;
    unsigned cnt;
    BINARYFILE file;
*/

extern void WriteLng(/* buf, cnt, file */);
/*
    unsigned long *buf;
    unsigned cnt;
    BINARYFILE file;
*/

extern void ReadUns(/* buf, cnt, file */);
/*
    unsigned *buf;
    unsigned cnt;
    BINARYFILE file;
*/

extern void WriteUns(/* buf, cnt, file */);
/*
    unsigned *buf;
    unsigned cnt;
    BINARYFILE file;
*/

extern void ReadData(/* buf, cnt, file */);
/*
    DATATYPE *buf;
    unsigned cnt;
    BINARYFILE file;
*/

extern void WriteData(/* buf, cnt, file */);
/*
    DATATYPE *buf;
    unsigned cnt;
    BINARYFILE file;
*/

extern void ReadChr(/* buf, cnt, file */);
/*
    register char *buf;
    register unsigned cnt;
    BINARYFILE file;
*/

extern void WriteChr(/* buf, cnt, file */);
/*
    register char *buf;
    register unsigned cnt;
    BINARYFILE file;
*/

#ifdef UNIX
#ifdef MAPTOMEM
extern void MapSkAbs(/* mmFile, pos */);
/*
    MMFILE *mmFile;
    unsigned long pos;
*/

extern void MapReLng(/* buf, cnt, mmFile */);
/*
    unsigned long *buf;
    unsigned cnt;
    MMFILE *mmFile;
*/

extern void MapWrLng(/* buf, cnt, mmFile */);
/*
    unsigned long *buf;
    unsigned cnt;
    MMFILE *mmFile;
*/

extern void MapReUns(/* buf, cnt, mmFile */);
/*
    unsigned *buf;
    unsigned cnt;
    MMFILE *mmFile;
*/

extern void MapWrUns(/* buf, cnt, mmFile */);
/*
    unsigned *buf;
    unsigned cnt;
    MMFILE *mmFile;
*/

extern void MapReData(/* buf, cnt, mmFile */);
/*
    DATATYPE *buf;
    unsigned cnt;
    MMFILE *mmFile;
*/

extern void MapWrData(/* buf, cnt, mmFile */);
/*
    DATATYPE *buf;
    unsigned cnt;
    MMFILE *mmFile;
*/

extern void MapReChr(/* buf, cnt, mmFile */);
/*
    char *buf;
    unsigned cnt;
    MMFILE *mmFile;
*/

extern void MapWrChr(/* buf, cnt, mmFile */);
/*
    char *buf;
    unsigned cnt;
    MMFILE *mmFile;
*/
#endif
#endif

/* LngAlloc creates an element of type unsigned long
 * and returns a pointer to it. */
#define LngAlloc() ((unsigned long *) Allocate(sizeof(unsigned long)))

/* LngCons constructs an element of type unsigned long,
 * assigns it to given value and returns a pointer to the element. */
extern unsigned long *LngCons(/* value */);
/*
    unsigned long value;
*/

/* LngCopy copies an element of type unsigned long
 * and returns a pointer to the copy. */
extern unsigned long *LngCopy(/* lng */);
/*
    unsigned long *lng;
*/

/* LngDump dumps an element of type unsigned long. */
extern void LngDump(/* lng, depth */);
/*
    unsigned long *lng;
    unsigned depth;
*/

extern TOOLS lngTools;
              /* = { (CFUNC) LngCopy, Deallocate, LngDump, NULL } */

extern int LngCompare();
extern BOOL LngPrefix();
extern BALTOOLS lngBalTools;

extern DATATYPE *DataCopy();
extern void DataDump();
extern TOOLS dataTools;
extern unsigned DataLen();
extern int DataCompare();
extern BOOL DataPrefix();
extern BALTOOLS dataBalTools;

extern BOOL StrPrefix();
extern BALTOOLS strBalTools;

typedef struct REF
{
    char *key;
    unsigned long slot;
} REF;

#define RefGKey(ref) ((ref)->key)
#define RefGSlot(ref) ((ref)->slot)

#define RefAlloc() ((REF *) Allocate(sizeof(REF)))
extern REF *RefCons();
extern REF *RefCopy();
#define RefDiscard(ref) Deallocate((char *) (ref))
extern void RefDump();
extern TOOLS refTools;
extern int RefKeyCmp();
extern BOOL RefPrefix();
extern BALTOOLS refBalTools;

extern int StrLstCompare();
extern BOOL StrLstPrefix();
extern BALTOOLS strLstBalTools;
