/***************************************************************************
*
* Copyright (c) 1989, 1990, 1991, 1992, 1993
* by Helsinki University of Technology, Digital Systems Laboratory.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  mark.h
*
* Part of: PROD's programs "gphgen", probe, and prpp
*
* Authors: Marko Rauhamaa and Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     .
*
* Version history:
*     $Log$
***************************************************************************/

#define TUPLE DOMAIN /* [MagGArity()] */
typedef struct {
  unsigned long count;
  unsigned long freeCount;
  TUPLE *tuple;
} TOKEN;
#define MARKING LIST /* of TOKENs */
typedef MARKING *STATE; /* [MagGNofPlaces()] */

extern unsigned magNofPlaces,*magProfile;
extern unsigned magArity;

#define MagGNofPlaces() magNofPlaces
#define MagGProfile(place) (magProfile[place])
#define MagIProfile(place,value) (magProfile[place] = (value))
#define MagGArity() magArity
#define MagSArity(arity) (magArity = (arity))

#define StaGMarking(state,place) ((state)[place])
#define StaIMarking(state,place,marking) ((state)[place] = (marking))
#define StaAlloc() ((STATE *) AllocArray(MagGNofPlaces(), sizeof(MARKING)))
extern STATE *StaFrCopy();
extern STATE *StaCopy();
extern void StaDiscard();
extern void StaDump();
extern TOOLS staTools;

#define MarEmpty(marking)  LstEmpty(marking)
#define MarBegin(marking)  ((TOKEN *) LstBegin(marking))
#define MarStep(marking)  ((TOKEN *) LstStep(marking))
#define MarFirst(marking) ((TOKEN *) LstFirst(marking))
#define MarGet(marking)  LstGet(marking)
#define MarSet(marking,cursor)  LstSet(marking, cursor)
extern void MarDelete();
extern void MarInsert();
#define MarInsLast(marking,token) \
    ((void) LstInsLast(marking, (NODE *) (token)))
#define MarInsNext(marking,token) \
    ((void) LstInsNext(marking, (NODE *) (token)))
#define MarDelNext(marking)  ((void) LstDelNext(marking, TRUE))
#define MarCreate() LstCreate(&tokTools)
#define MarCopy(marking) LstCopy(marking, TRUE)
#define MarDiscard(marking) LstDestroy(marking, TRUE)
extern void MarDump();
extern TOOLS marTools;
extern BOOL MarLess();
extern BOOL MarLequal();
#define MarGreater(marking1,marking2) MarLess(marking2, marking1)
#define MarGrequal(marking1,marking2) MarLequal(marking2, marking1)
extern BOOL MarEqual();
#define MarNequal(marking1,marking2) (!MarEqual(marking1, marking2))
extern MARKING *MarProduct();
extern MARKING *MarAdd();
extern MARKING *MarSubtract();
extern MARKING *MarIntersect();
extern MARKING *MarCatenate();

#define MARFOR(marking,token) LSTFOR(marking, token, TOKEN)

#define TokGTuple(token) ((token)->tuple)
#define TokITuple(token,_tuple) ((token)->tuple = (_tuple))
#define TokSTuple(token,_tuple) \
  (TupDiscard((token)->tuple), (token)->tuple = (_tuple))
#define TokGField(token,field) TupGField((token)->tuple, field)
#define TokSField(token,field,value) TupSField((token)->tuple, field, value)
#define TokGCount(token) ((token)->count)
#define TokSCount(token,_count) ((token)->count = (_count))
#define TokICount(token,_count) ((token)->count += (_count))
#define TokDCount(token,_count) ((token)->count -= (_count))
#define TokGFreeCount(token) ((token)->freeCount)
#define TokSFreeCount(token,_freeCount) ((token)->freeCount = (_freeCount))
#define TokIFreeCount(token,_freeCount) ((token)->freeCount += (_freeCount))
#define TokDFreeCount(token,_freeCount) ((token)->freeCount -= (_freeCount))
#define TokAlloc() (TOKEN *) Allocate(sizeof(TOKEN))
extern TOKEN *TokCons();
extern TOKEN *TokCopy();
extern void TokDiscard();
extern void TokDump();
extern TOOLS tokTools;

#define TupGField(tuple,field) ((tuple)[field])
#define TupSField(tuple,field,value) (tuple[field] = (value))
#define TupIncField(tuple,field) (tuple[field]++)
#define TupAlloc() \
    (MagGArity() ? (TUPLE *) AllocArray(MagGArity(), sizeof(DOMAIN)) \
     : (TUPLE *) NULL)
#define TupDiscard(tuple) \
    ((tuple) ? Deallocate((char *) (tuple)) : (void) NULL)
extern TUPLE *TupCopy();
extern void TupDc();
extern void TupDump();
extern int TupComp();
extern TOOLS tupTools;

