/***************************************************************************
*
* Copyright (c) 1989, 1990, 1991, 1992, 1993
* by Helsinki University of Technology, Digital Systems Laboratory.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  prod.h
*
* Part of: PROD's programs "gphgen", hashgen, probe, prod, prpp, strong,
*          and t
*
* Authors: Marko Rauhamaa and Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     .
*
* Version history:
*     $Log$
***************************************************************************/

#ifndef DOMAIN
#define DOMAIN int
#define UDOMAIN unsigned DOMAIN
/*
  To be remembered when defining MINDOMAIN and MAXDOMAIN:
  1) Types have not been included in the constant expression syntax
     of "prpp". Types have not been included in the expression syntax
     of "probe" either. MINDOMAIN and MAXDOMAIN should thus be defined
     without any cast.
  2) "probe" casts its input expressions to type long.
     MINDOMAIN and MAXDOMAIN should be interpreted in the most
     natural way. (Example: If DOMAIN is a signed type then
     (long) MINDOMAIN should have the same absolute value and
     sign as (DOMAIN) MINDOMAIN.)
  3) Avoid overflow in operations and numbers. (Example: Below
     it is better not to define MINDOMAIN as (-2147483648) or (-32768).)
  4) Right shift operation (>>) is sign preserving in some machines.
     (Example: If >> is sign preserving then ((-1) >> 1) is
     equivalent to -1 instead of MAXINT.)
*/
#ifdef UNIX
#define MAXDOMAIN 2147483647
#else
#define MAXDOMAIN 32767
#endif
#define MINDOMAIN (~MAXDOMAIN)
#endif
#ifndef BITSPERBYTE
#define BITSPERBYTE 8
#endif
#ifndef DATATYPE
#define DATATYPE unsigned char
#endif
#ifndef BOOL
#define BOOL int
#endif
#ifndef FALSE
#define FALSE 0
#define TRUE 1
#endif
