/************************************************************************
 *			
 * 	Module	: $Id$	
 *	Auteur	: $Author$
 *	Date	: $Date$
 *	Sujet	: Gestionnaire de license pour AMI
 *									
 ************************************************************************/

#define DLM_RETURN_CODES_H

/* Les differents codes d'erreur du gestionnaire de licenses */

#define MEMORY_ERROR			500
#define DLM_CONNECT_ERROR		501
#define DLM_CANNOT_OPEN			502

#define DLM_INVALID_DATA		100
#define DLM_INVALID_HOSTID		101
#define DLM_INVALID_PASSWORD		102
#define DLM_UNKNOWN_SOFT		103
#define DLM_NO_TOKENS			104
#define DLM_INVALID_LICENSE		105
#define DLM_UNKNOWN_HOST		106
#define DLM_EXPIRED			107
#define DLM_INVALID_REQUEST		108
#define DLM_DENIED			109

/* Les requetes pour le serveur */

#define DLM_SOFT_REQ			1000
#define DLM_HOST_REQ			1001
#define DLM_REL_SOFT_REQ		1002


/* Les valeurs de retour sans erreurs */

#define DLM_OK				1

/* Les types communs */

struct IdentHosts {
	Boolean license_OK;
	int err_code;
	char org[65];
	char hostid[20];
	char password[25];
	char date[10];
	};
	
struct IdentSofts {
	Boolean license_OK;
	int err_code;
	char name[65];
	int tokens;
	int usedTokens;
	char date[10];
	char password[25];
	};
	
typedef struct IdentHosts *T_IdentHost;
typedef struct IdentSofts *T_IdentSoft;


/* les prototypes de fonctions */

#if defined(__STRIC_ANSI__) && !defined(_LICENSE_C_)

void DLM_InitLicense( char *path );
void DLM_GetSalt( char *string, char *salt);
char *DLM_CryptString( char *string, char *salt);
int DLM_GetSoftLicense( char *name );
int DLM_GetHostLicense( char *hostid );
int DLM_ReleaseSoftLicense( char *name );

#endif



